Update notification settings

Note: This endpoint is in preview and is subject to change. If you have any feedback, contact Datadog support.

PATCH https://api.ap1.datadoghq.com/api/v2/governance/notification_settingshttps://api.ap2.datadoghq.com/api/v2/governance/notification_settingshttps://api.datadoghq.eu/api/v2/governance/notification_settingshttps://api.ddog-gov.com/api/v2/governance/notification_settingshttps://api.us2.ddog-gov.com/api/v2/governance/notification_settingshttps://api.uk1.datadoghq.com/api/v2/governance/notification_settingshttps://api.datadoghq.com/api/v2/governance/notification_settingshttps://api.us3.datadoghq.com/api/v2/governance/notification_settingshttps://api.us5.datadoghq.com/api/v2/governance/notification_settings

Overview

Update the organization-wide governance notification settings. Only the attributes present in the request are modified. This endpoint requires all of the following permissions:

  • governance_console_read
  • governance_console_write

  • Request

    Body Data (required)

    Expand All

    Field

    Type

    Description

    data [required]

    object

    The data of a governance notification settings update request.

    attributes

    object

    The attributes of the governance notification settings that can be updated. Only the attributes present in the request are modified.

    assignment_notifications_enabled

    boolean

    Whether notifications are sent to users when detections are assigned to them.

    type [required]

    enum

    Governance notification settings resource type. Allowed enum values: governance_notification_settings

    {
      "data": {
        "attributes": {
          "assignment_notifications_enabled": true
        },
        "type": "governance_notification_settings"
      }
    }

    Response

    OK

    The organization-wide governance notification settings.

    Expand All

    Field

    Type

    Description

    data [required]

    object

    A governance notification settings resource.

    attributes [required]

    object

    The attributes of the organization-wide governance notification settings.

    assignment_notifications_enabled [required]

    boolean

    Whether notifications are sent to users when detections are assigned to them.

    id [required]

    string

    The unique identifier of the organization the notification settings apply to.

    type [required]

    enum

    Governance notification settings resource type. Allowed enum values: governance_notification_settings

    {
      "data": {
        "attributes": {
          "assignment_notifications_enabled": true
        },
        "id": "11111111-2222-3333-4444-555555555555",
        "type": "governance_notification_settings"
      }
    }

    Bad Request

    API error response.

    Expand All

    Field

    Type

    Description

    errors [required]

    [object]

    A list of errors.

    detail

    string

    A human-readable explanation specific to this occurrence of the error.

    meta

    object

    Non-standard meta-information about the error

    source

    object

    References to the source of the error.

    header

    string

    A string indicating the name of a single request header which caused the error.

    parameter

    string

    A string indicating which URI query parameter caused the error.

    pointer

    string

    A JSON pointer to the value in the request document that caused the error.

    status

    string

    Status code of the response.

    title

    string

    Short human-readable summary of the error.

    {
      "errors": [
        {
          "detail": "Missing required attribute in body",
          "meta": {},
          "source": {
            "header": "Authorization",
            "parameter": "limit",
            "pointer": "/data/attributes/title"
          },
          "status": "400",
          "title": "Bad Request"
        }
      ]
    }

    Unauthorized

    API error response.

    Expand All

    Field

    Type

    Description

    errors [required]

    [object]

    A list of errors.

    detail

    string

    A human-readable explanation specific to this occurrence of the error.

    meta

    object

    Non-standard meta-information about the error

    source

    object

    References to the source of the error.

    header

    string

    A string indicating the name of a single request header which caused the error.

    parameter

    string

    A string indicating which URI query parameter caused the error.

    pointer

    string

    A JSON pointer to the value in the request document that caused the error.

    status

    string

    Status code of the response.

    title

    string

    Short human-readable summary of the error.

    {
      "errors": [
        {
          "detail": "Missing required attribute in body",
          "meta": {},
          "source": {
            "header": "Authorization",
            "parameter": "limit",
            "pointer": "/data/attributes/title"
          },
          "status": "400",
          "title": "Bad Request"
        }
      ]
    }

    Forbidden

    API error response.

    Expand All

    Field

    Type

    Description

    errors [required]

    [object]

    A list of errors.

    detail

    string

    A human-readable explanation specific to this occurrence of the error.

    meta

    object

    Non-standard meta-information about the error

    source

    object

    References to the source of the error.

    header

    string

    A string indicating the name of a single request header which caused the error.

    parameter

    string

    A string indicating which URI query parameter caused the error.

    pointer

    string

    A JSON pointer to the value in the request document that caused the error.

    status

    string

    Status code of the response.

    title

    string

    Short human-readable summary of the error.

    {
      "errors": [
        {
          "detail": "Missing required attribute in body",
          "meta": {},
          "source": {
            "header": "Authorization",
            "parameter": "limit",
            "pointer": "/data/attributes/title"
          },
          "status": "400",
          "title": "Bad Request"
        }
      ]
    }

    Too many requests

    API error response.

    Expand All

    Field

    Type

    Description

    errors [required]

    [string]

    A list of errors.

    {
      "errors": [
        "Bad Request"
      ]
    }

    Code Example

                      ## default
    # 
    
    # Curl command
    curl -X PATCH "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/governance/notification_settings" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -H "DD-API-KEY: ${DD_API_KEY}" \ -H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \ -d @- << EOF { "data": { "attributes": { "assignment_notifications_enabled": true }, "type": "governance_notification_settings" } } EOF
    """
    Update notification settings returns "OK" response
    """
    
    from datadog_api_client import ApiClient, Configuration
    from datadog_api_client.v2.api.governance_console_api import GovernanceConsoleApi
    from datadog_api_client.v2.model.governance_notification_settings_resource_type import (
        GovernanceNotificationSettingsResourceType,
    )
    from datadog_api_client.v2.model.governance_notification_settings_update_attributes import (
        GovernanceNotificationSettingsUpdateAttributes,
    )
    from datadog_api_client.v2.model.governance_notification_settings_update_data import (
        GovernanceNotificationSettingsUpdateData,
    )
    from datadog_api_client.v2.model.governance_notification_settings_update_request import (
        GovernanceNotificationSettingsUpdateRequest,
    )
    
    body = GovernanceNotificationSettingsUpdateRequest(
        data=GovernanceNotificationSettingsUpdateData(
            attributes=GovernanceNotificationSettingsUpdateAttributes(
                assignment_notifications_enabled=True,
            ),
            type=GovernanceNotificationSettingsResourceType.GOVERNANCE_NOTIFICATION_SETTINGS,
        ),
    )
    
    configuration = Configuration()
    configuration.unstable_operations["update_governance_notification_settings"] = True
    with ApiClient(configuration) as api_client:
        api_instance = GovernanceConsoleApi(api_client)
        response = api_instance.update_governance_notification_settings(body=body)
    
        print(response)
    

    Instructions

    First install the library and its dependencies and then save the example to example.py and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
    # Update notification settings returns "OK" response
    
    require "datadog_api_client"
    DatadogAPIClient.configure do |config|
      config.unstable_operations["v2.update_governance_notification_settings".to_sym] = true
    end
    api_instance = DatadogAPIClient::V2::GovernanceConsoleAPI.new
    
    body = DatadogAPIClient::V2::GovernanceNotificationSettingsUpdateRequest.new({
      data: DatadogAPIClient::V2::GovernanceNotificationSettingsUpdateData.new({
        attributes: DatadogAPIClient::V2::GovernanceNotificationSettingsUpdateAttributes.new({
          assignment_notifications_enabled: true,
        }),
        type: DatadogAPIClient::V2::GovernanceNotificationSettingsResourceType::GOVERNANCE_NOTIFICATION_SETTINGS,
      }),
    })
    p api_instance.update_governance_notification_settings(body)
    

    Instructions

    First install the library and its dependencies and then save the example to example.rb and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
    // Update notification settings returns "OK" response
    
    package main
    
    import (
    	"context"
    	"encoding/json"
    	"fmt"
    	"os"
    
    	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
    	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
    )
    
    func main() {
    	body := datadogV2.GovernanceNotificationSettingsUpdateRequest{
    		Data: datadogV2.GovernanceNotificationSettingsUpdateData{
    			Attributes: &datadogV2.GovernanceNotificationSettingsUpdateAttributes{
    				AssignmentNotificationsEnabled: datadog.PtrBool(true),
    			},
    			Type: datadogV2.GOVERNANCENOTIFICATIONSETTINGSRESOURCETYPE_GOVERNANCE_NOTIFICATION_SETTINGS,
    		},
    	}
    	ctx := datadog.NewDefaultContext(context.Background())
    	configuration := datadog.NewConfiguration()
    	configuration.SetUnstableOperationEnabled("v2.UpdateGovernanceNotificationSettings", true)
    	apiClient := datadog.NewAPIClient(configuration)
    	api := datadogV2.NewGovernanceConsoleApi(apiClient)
    	resp, r, err := api.UpdateGovernanceNotificationSettings(ctx, body)
    
    	if err != nil {
    		fmt.Fprintf(os.Stderr, "Error when calling `GovernanceConsoleApi.UpdateGovernanceNotificationSettings`: %v\n", err)
    		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
    	}
    
    	responseContent, _ := json.MarshalIndent(resp, "", "  ")
    	fmt.Fprintf(os.Stdout, "Response from `GovernanceConsoleApi.UpdateGovernanceNotificationSettings`:\n%s\n", responseContent)
    }
    

    Instructions

    First install the library and its dependencies and then save the example to main.go and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
    // Update notification settings returns "OK" response
    
    import com.datadog.api.client.ApiClient;
    import com.datadog.api.client.ApiException;
    import com.datadog.api.client.v2.api.GovernanceConsoleApi;
    import com.datadog.api.client.v2.model.GovernanceNotificationSettingsResourceType;
    import com.datadog.api.client.v2.model.GovernanceNotificationSettingsResponse;
    import com.datadog.api.client.v2.model.GovernanceNotificationSettingsUpdateAttributes;
    import com.datadog.api.client.v2.model.GovernanceNotificationSettingsUpdateData;
    import com.datadog.api.client.v2.model.GovernanceNotificationSettingsUpdateRequest;
    
    public class Example {
      public static void main(String[] args) {
        ApiClient defaultClient = ApiClient.getDefaultApiClient();
        defaultClient.setUnstableOperationEnabled("v2.updateGovernanceNotificationSettings", true);
        GovernanceConsoleApi apiInstance = new GovernanceConsoleApi(defaultClient);
    
        GovernanceNotificationSettingsUpdateRequest body =
            new GovernanceNotificationSettingsUpdateRequest()
                .data(
                    new GovernanceNotificationSettingsUpdateData()
                        .attributes(
                            new GovernanceNotificationSettingsUpdateAttributes()
                                .assignmentNotificationsEnabled(true))
                        .type(
                            GovernanceNotificationSettingsResourceType
                                .GOVERNANCE_NOTIFICATION_SETTINGS));
    
        try {
          GovernanceNotificationSettingsResponse result =
              apiInstance.updateGovernanceNotificationSettings(body);
          System.out.println(result);
        } catch (ApiException e) {
          System.err.println(
              "Exception when calling GovernanceConsoleApi#updateGovernanceNotificationSettings");
          System.err.println("Status code: " + e.getCode());
          System.err.println("Reason: " + e.getResponseBody());
          System.err.println("Response headers: " + e.getResponseHeaders());
          e.printStackTrace();
        }
      }
    }
    

    Instructions

    First install the library and its dependencies and then save the example to Example.java and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
    // Update notification settings returns "OK" response
    use datadog_api_client::datadog;
    use datadog_api_client::datadogV2::api_governance_console::GovernanceConsoleAPI;
    use datadog_api_client::datadogV2::model::GovernanceNotificationSettingsResourceType;
    use datadog_api_client::datadogV2::model::GovernanceNotificationSettingsUpdateAttributes;
    use datadog_api_client::datadogV2::model::GovernanceNotificationSettingsUpdateData;
    use datadog_api_client::datadogV2::model::GovernanceNotificationSettingsUpdateRequest;
    
    #[tokio::main]
    async fn main() {
        let body = GovernanceNotificationSettingsUpdateRequest::new(
            GovernanceNotificationSettingsUpdateData::new(
                GovernanceNotificationSettingsResourceType::GOVERNANCE_NOTIFICATION_SETTINGS,
            )
            .attributes(
                GovernanceNotificationSettingsUpdateAttributes::new()
                    .assignment_notifications_enabled(true),
            ),
        );
        let mut configuration = datadog::Configuration::new();
        configuration.set_unstable_operation_enabled("v2.UpdateGovernanceNotificationSettings", true);
        let api = GovernanceConsoleAPI::with_config(configuration);
        let resp = api.update_governance_notification_settings(body).await;
        if let Ok(value) = resp {
            println!("{:#?}", value);
        } else {
            println!("{:#?}", resp.unwrap_err());
        }
    }
    

    Instructions

    First install the library and its dependencies and then save the example to src/main.rs and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
    /**
     * Update notification settings returns "OK" response
     */
    
    import { client, v2 } from "@datadog/datadog-api-client";
    
    const configuration = client.createConfiguration();
    configuration.unstableOperations["v2.updateGovernanceNotificationSettings"] =
      true;
    const apiInstance = new v2.GovernanceConsoleApi(configuration);
    
    const params: v2.GovernanceConsoleApiUpdateGovernanceNotificationSettingsRequest =
      {
        body: {
          data: {
            attributes: {
              assignmentNotificationsEnabled: true,
            },
            type: "governance_notification_settings",
          },
        },
      };
    
    apiInstance
      .updateGovernanceNotificationSettings(params)
      .then((data: v2.GovernanceNotificationSettingsResponse) => {
        console.log(
          "API called successfully. Returned data: " + JSON.stringify(data)
        );
      })
      .catch((error: any) => console.error(error));
    

    Instructions

    First install the library and its dependencies and then save the example to example.ts and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"